function whichAnimationEvent(){
  var t, el = document.createElement("fakeelement");

  var animations = {
    "animation"      : "animationend",
    "OAnimation"     : "oAnimationEnd",
    "MozAnimation"   : "animationend",
    "WebkitAnimation": "webkitAnimationEnd"
  }

  for (t in animations){
    if (el.style[t] !== undefined){
      return animations[t];
    }
  }
}
var animationEvent = whichAnimationEvent();

var j = jQuery.noConflict();

function startAnimation() {

	var pu = woo_loader_settings;

	//if(pu.entrance != "none") j('body').wrapInner('<div id="page-entrance-wrapper"></div>');
	if(j('body').find('.woo-loader-container').length == 0)
		j('body').prepend(pu['spinner']);

	if(pu['text_spinner'] != "" && pu['text_spinner'] != undefined){
		var pt = 0;
		if(pu['type'] == "css"){
			pt = j('.woo-loader-container > *').height()+60; //compute the text padding
		}else{
			pt = parseInt(pu['width'])+60;
		}
		j('.woo-loader-container').append('<div style="padding-top:'+pt+'px" class="center-spin preloader-text">'+pu['text_spinner']+'</div>');
	}

	j('body').removeClass('woo-loader').css({overflow:'hidden'});
}

function stopAnimation() {
	var pu = woo_loader_settings;
	var delay = (pu.delay < 700 && pu.entrance != "none") ? 700 : pu.delay;

	var exit_duration = { 
		'-webkit-animation-duration':pu.duration,
		'-moz-animation-duration':pu.duration,
		'-ms-animation-duration':pu.duration,
		'-o-animation-duration':pu.duration,
		'animation-duration':pu.duration
	};
	var anim_class = 'animated '+pu.exit_anim;

	setTimeout(function(){
		j('.woo-loader-container').css(exit_duration).addClass(anim_class).one(animationEvent, function(){
			j(this).remove(); //remove the loading element
			j('body').css({overflow:'unset'});
			if(pu.entrance == "none"){
				if(j('link[href*="html-overflow.css"]').length != 0) 
					j('link[href*="html-overflow.css"]')[0].disabled=true; 
			}
		});
	},delay);
}
function getURLParam(p, url) {
    p = p.replace(/[\[\]]/g, '\\$&');
    var regex = new RegExp('[?&]' + p + '(=([^&#]*)|&|#|$)'),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

jQuery( document )
    .ajaxComplete(function( event, request, settings) {
        var wcAction =  getURLParam("wc-ajax", settings.url);
        if(wcAction == "checkout") {
            if("result" in request.responseJSON && request.responseJSON.result == "success") return false;
            stopAnimation();
        }
    });

jQuery(document).ready(function($){
    var chkOutForm = $('form.woocommerce-checkout');

	chkOutForm.on('submit', function(){
		startAnimation();

        var chkOutFrmData = chkOutForm.serializeArray();
        var shipToDifferentAddress = extractFormInpData(chkOutFrmData, "ship_to_different_address");
        var paymentMethod = extractFormInpData(chkOutFrmData, "payment_method");

        var processInterval = window.setInterval(function(){
            if (paymentMethod == "stripe" && chkOutForm.find(".woocommerce_error").length != 0) {
                stopAnimation();
                clearInterval(processInterval);
            }
        }, 100);
    });
});

function extractFormInpData(ar, keyToFind) {
	if(ar.length > 0) {
		var foundDat = false;
		jQuery.each(ar, function(k,v){
			if(v.name == keyToFind) {
                foundDat = v.value;
                return false;
			}
		});
		return foundDat;
	}
}
